Index: LMDZ6/branches/Amaury_dev/libf/phylmd/surf_landice_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/surf_landice_mod.F90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/surf_landice_mod.F90	(revision 5102)
@@ -411,210 +402,207 @@
 #endif         
 
-    CALL calcul_flux_wind(knon, dtime, &
-         u0, v0, u1, v1, gustiness, cdragm, &
-         AcoefU, AcoefV, BcoefU, BcoefV, &
-         p1lay, temp_air, &
-         flux_u1, flux_v1)
-
-
-!****************************************************************************************
-! Calculate albedo
-
-!****************************************************************************************
-
-!IM: plusieurs choix/tests sur l'albedo des "glaciers continentaux"
-!       alb1(1 : knon)  = 0.6 !IM cf FH/GK 
-!       alb1(1 : knon)  = 0.82
-!       alb1(1 : knon)  = 0.77 !211003 Ksta0.77
-!       alb1(1 : knon)  = 0.8 !KstaTER0.8 & LMD_ARMIP5
-!IM: KstaTER0.77 & LMD_ARMIP6    
-
-! Attantion: alb1 and alb2 are not the same!
-    alb1(1:knon)  = alb_vis_sno_lic
-    alb2(1:knon)  = alb_nir_sno_lic
-
-
-!****************************************************************************************
-! Rugosity
-
-!****************************************************************************************
-
-if (z0m_landice > 0.) then
-    z0m(1:knon) = z0m_landice
-    z0h(1:knon) = z0h_landice
-else
-    ! parameterization of z0=f(T) following measurements in Adelie Land by Amory et al 2018
-    coefa = 0.1658 !0.1862 !Ant
-    coefb = -50.3869 !-55.7718 !Ant
-    ta1 = 253.15 !255. Ant
-    ta2 = 273.15
-    ta3 = 273.15+3
-    z01 = exp(coefa*ta1 + coefb) !~0.2 ! ~0.25 mm
-    z02 = exp(coefa*ta2 + coefb) !~6  !~7 mm
-    z03 = z01
-    coefc = log(z03/z02)/(ta3-ta2)
-    coefd = log(z03)-coefc*ta3
-    do j=1,knon 
-      if (temp_air(j) < ta1) then
-        z0m(j) = z01
-      else if (temp_air(j)>=ta1 .and. temp_air(j)<ta2) then
-        z0m(j) = exp(coefa*temp_air(j) + coefb)
-      else if (temp_air(j)>=ta2 .and. temp_air(j)<ta3) then
-        ! if st > 0, melting induce smooth surface
-        z0m(j) = exp(coefc*temp_air(j) + coefd)
+      CALL calcul_flux_wind(knon, dtime, &
+              u0, v0, u1, v1, gustiness, cdragm, &
+              AcoefU, AcoefV, BcoefU, BcoefV, &
+              p1lay, temp_air, &
+              flux_u1, flux_v1)
+
+
+      !****************************************************************************************
+      ! Calculate albedo
+
+      !****************************************************************************************
+
+      !IM: plusieurs choix/tests sur l'albedo des "glaciers continentaux"
+      !       alb1(1 : knon)  = 0.6 !IM cf FH/GK
+      !       alb1(1 : knon)  = 0.82
+      !       alb1(1 : knon)  = 0.77 !211003 Ksta0.77
+      !       alb1(1 : knon)  = 0.8 !KstaTER0.8 & LMD_ARMIP5
+      !IM: KstaTER0.77 & LMD_ARMIP6
+
+      ! Attantion: alb1 and alb2 are not the same!
+      alb1(1:knon) = alb_vis_sno_lic
+      alb2(1:knon) = alb_nir_sno_lic
+
+
+      !****************************************************************************************
+      ! Rugosity
+
+      !****************************************************************************************
+
+      if (z0m_landice > 0.) then
+        z0m(1:knon) = z0m_landice
+        z0h(1:knon) = z0h_landice
       else
-        z0m(j) = z03
+        ! parameterization of z0=f(T) following measurements in Adelie Land by Amory et al 2018
+        coefa = 0.1658 !0.1862 !Ant
+        coefb = -50.3869 !-55.7718 !Ant
+        ta1 = 253.15 !255. Ant
+        ta2 = 273.15
+        ta3 = 273.15 + 3
+        z01 = exp(coefa * ta1 + coefb) !~0.2 ! ~0.25 mm
+        z02 = exp(coefa * ta2 + coefb) !~6  !~7 mm
+        z03 = z01
+        coefc = log(z03 / z02) / (ta3 - ta2)
+        coefd = log(z03) - coefc * ta3
+        do j = 1, knon
+          if (temp_air(j) < ta1) then
+            z0m(j) = z01
+          else if (temp_air(j)>=ta1 .and. temp_air(j)<ta2) then
+            z0m(j) = exp(coefa * temp_air(j) + coefb)
+          else if (temp_air(j)>=ta2 .and. temp_air(j)<ta3) then
+            ! if st > 0, melting induce smooth surface
+            z0m(j) = exp(coefc * temp_air(j) + coefd)
+          else
+            z0m(j) = z03
+          endif
+          z0h(j) = z0m(j)
+        enddo
+
       endif
-      z0h(j)=z0m(j)
-    enddo
-
-endif    
- 
-
-!****************************************************************************************
-! Simple blowing snow param
-!****************************************************************************************
-! we proceed in 2 steps:
-! first we erode - if possible -the accumulated snow during the time step
-! then we update the density of the underlying layer and see if we can also erode
-! this layer
-
-
-   if (ok_bs) then
-       fluxbs(:)=0.
-       do j=1,knon
-          ws1(j)=(u1(j)**2+v1(j)**2)**0.5
-          ustar(j)=(cdragm(j)*(u1(j)**2+v1(j)**2))**0.5
-          rhod(j)=p1lay(j)/RD/temp_air(j)
-          ustart0(j) =(log(2.868)-log(1.625))/0.085*sqrt(cdragm(j))
-       enddo
-
-       ! 1st step: erosion of fresh snow accumulated during the time step
-       do j=1, knon
-       if (precip_snow(j) > 0.) then
-           rhos(j)=rhofresh_bs
-           ! blowing snow flux formula used in MAR
-           ustart(j)=ustart0(j)*exp(max(rhoice_bs/rhofresh_bs-rhoice_bs/rhos(j),0.))*exp(max(0.,rhos(j)-rhohard_bs))
-           ! we have multiplied by exp to prevent erosion when rhos>rhohard_bs 
-           ! computation of qbs at the top of the saltation layer
-           ! default formulation from MAR model (Amory et al. 2021, Gallee et al. 2001)
-           esalt=1./(c_esalt_bs*max(1.e-6,ustar(j)))
-           hsalt(j)=0.08436*(max(1.e-6,ustar(j))**1.27)
-           qsalt(j)=(max(ustar(j)**2-ustart(j)**2,0.))/(RG*hsalt(j))*esalt
-           ! calculation of erosion (flux positive towards the surface here) 
-           ! consistent with implicit resolution of turbulent mixing equation
-           ! Nemoto and Nishimura 2004 show that steady-state saltation is achieved within a time tau_eqsalt_bs of about 10s
-           ! we thus prevent snowerosion (snow particle transfer from the saltation layer to the first model level)
-           ! integrated over tau_eqsalt_bs to exceed the total mass of snow particle in the saltation layer
-           ! (rho*qsalt*hsalt)
-           ! during this first step we also lower bound the erosion to the amount of fresh snow accumulated during the time step
-           maxerosion=min(precip_snow(j),hsalt(j)*qsalt(j)*rhod(j)/tau_eqsalt_bs)
-
-           fluxbs_1(j)=rhod(j)*ws1(j)*cdragh(j)*zeta_bs*(AcoefQBS(j)-qsalt(j)) &
-                   / (1.-rhod(j)*ws1(j)*cdragh(j)*zeta_bs*BcoefQBS(j)*dtime)
-           fluxbs_1(j)=max(-maxerosion,fluxbs_1(j))
-
-           if (precip_snow(j) > abs(fluxbs_1(j))) then
-               ok_remaining_freshsnow(j)=.true.
-               bsweight_fresh(j)=1.
-           else
-               ok_remaining_freshsnow(j)=.false.
-               bsweight_fresh(j)=exp(-(abs(fluxbs_1(j))-precip_snow(j))/precip_snow(j))
-           endif
-       else
-           ok_remaining_freshsnow(j)=.false.
-           fluxbs_1(j)=0.
-           bsweight_fresh(j)=0.
-       endif
-       enddo
-
-
-       ! we now compute the snow age of the overlying layer (snow surface after erosion of the fresh snow accumulated during the time step)
-       ! this is done through the routine albsno
-       CALL albsno(klon,knon,dtime,agesno(:),alb_neig(:), precip_snow(:)+fluxbs_1(:))
-
-       ! 2nd step:
-       ! computation of threshold friction velocity
-       ! which depends on surface snow density
-       do j = 1, knon
-        if (ok_remaining_freshsnow(j)) then
-           fluxbs_2(j)=0.
-        else
-           ! we start eroding the underlying layer
-           ! estimation of snow density
-           ! snow density increases with snow age and
-           ! increases even faster in case of sedimentation of blowing snow or rain
-           tau_dens=max(tau_densmin_bs, tau_dens0_bs*exp(-abs(precip_bs(j))/pbst_bs - & 
-                    abs(precip_rain(j))/prt_bs)*exp(-max(tsurf(j)-RTT,0.)))
-           rhos(j)=rhofresh_bs+(rhohard_bs-rhofresh_bs)*(1.-exp(-agesno(j)*86400.0/tau_dens))
-           ! blowing snow flux formula used in MAR
-           ustart(j)=ustart0(j)*exp(max(rhoice_bs/rhofresh_bs-rhoice_bs/rhos(j),0.))*exp(max(0.,rhos(j)-rhohard_bs)) 
-           ! we have multiplied by exp to prevent erosion when rhos>rhohard_bs 
-           ! computation of qbs at the top of the saltation layer
-           ! default formulation from MAR model (Amory et al. 2021, Gallee et al. 2001)
-           esalt=1./(c_esalt_bs*max(1.e-6,ustar(j)))
-           hsalt(j)=0.08436*(max(1.e-6,ustar(j))**1.27)
-           qsalt(j)=(max(ustar(j)**2-ustart(j)**2,0.))/(RG*hsalt(j))*esalt
-           ! calculation of erosion (flux positive towards the surface here) 
-           ! consistent with implicit resolution of turbulent mixing equation
-           ! Nemoto and Nishimura 2004 show that steady-state saltation is achieved within a time tau_eqsalt_bs of about 10s
-           ! we thus prevent snowerosion (snow particle transfer from the saltation layer to the first model level)
-           ! integrated over tau_eqsalt_bs to exceed the total mass of snow particle in the saltation layer
-           ! (rho*qsalt*hsalt)
-           maxerosion=hsalt(j)*qsalt(j)*rhod(j)/tau_eqsalt_bs
-           fluxbs_2(j)=rhod(j)*ws1(j)*cdragh(j)*zeta_bs*(AcoefQBS(j)-qsalt(j)) &
-                   / (1.-rhod(j)*ws1(j)*cdragh(j)*zeta_bs*BcoefQBS(j)*dtime)
-           fluxbs_2(j)=max(-maxerosion,fluxbs_2(j))
-         endif
-       enddo
-
-
-
-
-       ! final flux and outputs       
-        do j=1, knon
-              ! total flux is the erosion of fresh snow + 
-              ! a fraction of the underlying snow (if all the fresh snow has been eroded)
-              ! the calculation of the fraction is quite delicate since we do not know
-              ! how much time was needed to erode the fresh snow. We assume that this time
-              ! is dt*exp(-(abs(fluxbs1)-precipsnow)/precipsnow)=dt*bsweight_fresh
-
-              fluxbs(j)=fluxbs_1(j)+fluxbs_2(j)*(1.-bsweight_fresh(j))
-              i = knindex(j)
-              zxustartlic(i) = ustart(j)
-              zxrhoslic(i) = rhos(j)
-              zxqsaltlic(i)=qsalt(j)
+
+
+      !****************************************************************************************
+      ! Simple blowing snow param
+      !****************************************************************************************
+      ! we proceed in 2 steps:
+      ! first we erode - if possible -the accumulated snow during the time step
+      ! then we update the density of the underlying layer and see if we can also erode
+      ! this layer
+
+      if (ok_bs) then
+        fluxbs(:) = 0.
+        do j = 1, knon
+          ws1(j) = (u1(j)**2 + v1(j)**2)**0.5
+          ustar(j) = (cdragm(j) * (u1(j)**2 + v1(j)**2))**0.5
+          rhod(j) = p1lay(j) / RD / temp_air(j)
+          ustart0(j) = (log(2.868) - log(1.625)) / 0.085 * sqrt(cdragm(j))
         enddo
 
-
-  else ! not ok_bs
-  ! those lines are useful to calculate the snow age
-       CALL albsno(klon,knon,dtime,agesno(:),alb_neig(:), precip_snow(:))
-
-  endif ! if ok_bs
-
-
-
-!****************************************************************************************
-! Calculate snow amount
-
-!****************************************************************************************
-    IF (ok_bs) THEN
-      precip_totsnow(:)=precip_snow(:)+precip_bs(:)
-      evap_totsnow(:)=evap(:)-fluxbs(:) ! flux bs is positive towards the surface (snow erosion)
-    ELSE
-      precip_totsnow(:)=precip_snow(:)
-      evap_totsnow(:)=evap(:)
-    ENDIF
-    
- 
-    CALL fonte_neige(knon, is_lic, knindex, dtime, &
-         tsurf, precip_rain, precip_totsnow, &
-         snow, qsol, tsurf_new, evap_totsnow &
+        ! 1st step: erosion of fresh snow accumulated during the time step
+        do j = 1, knon
+          if (precip_snow(j) > 0.) then
+            rhos(j) = rhofresh_bs
+            ! blowing snow flux formula used in MAR
+            ustart(j) = ustart0(j) * exp(max(rhoice_bs / rhofresh_bs - rhoice_bs / rhos(j), 0.)) * exp(max(0., rhos(j) - rhohard_bs))
+            ! we have multiplied by exp to prevent erosion when rhos>rhohard_bs
+            ! computation of qbs at the top of the saltation layer
+            ! default formulation from MAR model (Amory et al. 2021, Gallee et al. 2001)
+            esalt = 1. / (c_esalt_bs * max(1.e-6, ustar(j)))
+            hsalt(j) = 0.08436 * (max(1.e-6, ustar(j))**1.27)
+            qsalt(j) = (max(ustar(j)**2 - ustart(j)**2, 0.)) / (RG * hsalt(j)) * esalt
+            ! calculation of erosion (flux positive towards the surface here)
+            ! consistent with implicit resolution of turbulent mixing equation
+            ! Nemoto and Nishimura 2004 show that steady-state saltation is achieved within a time tau_eqsalt_bs of about 10s
+            ! we thus prevent snowerosion (snow particle transfer from the saltation layer to the first model level)
+            ! integrated over tau_eqsalt_bs to exceed the total mass of snow particle in the saltation layer
+            ! (rho*qsalt*hsalt)
+            ! during this first step we also lower bound the erosion to the amount of fresh snow accumulated during the time step
+            maxerosion = min(precip_snow(j), hsalt(j) * qsalt(j) * rhod(j) / tau_eqsalt_bs)
+
+            fluxbs_1(j) = rhod(j) * ws1(j) * cdragh(j) * zeta_bs * (AcoefQBS(j) - qsalt(j)) &
+                    / (1. - rhod(j) * ws1(j) * cdragh(j) * zeta_bs * BcoefQBS(j) * dtime)
+            fluxbs_1(j) = max(-maxerosion, fluxbs_1(j))
+
+            if (precip_snow(j) > abs(fluxbs_1(j))) then
+              ok_remaining_freshsnow(j) = .true.
+              bsweight_fresh(j) = 1.
+            else
+              ok_remaining_freshsnow(j) = .false.
+              bsweight_fresh(j) = exp(-(abs(fluxbs_1(j)) - precip_snow(j)) / precip_snow(j))
+            endif
+          else
+            ok_remaining_freshsnow(j) = .false.
+            fluxbs_1(j) = 0.
+            bsweight_fresh(j) = 0.
+          endif
+        enddo
+
+
+        ! we now compute the snow age of the overlying layer (snow surface after erosion of the fresh snow accumulated during the time step)
+        ! this is done through the routine albsno
+        CALL albsno(klon, knon, dtime, agesno(:), alb_neig(:), precip_snow(:) + fluxbs_1(:))
+
+        ! 2nd step:
+        ! computation of threshold friction velocity
+        ! which depends on surface snow density
+        do j = 1, knon
+          if (ok_remaining_freshsnow(j)) then
+            fluxbs_2(j) = 0.
+          else
+            ! we start eroding the underlying layer
+            ! estimation of snow density
+            ! snow density increases with snow age and
+            ! increases even faster in case of sedimentation of blowing snow or rain
+            tau_dens = max(tau_densmin_bs, tau_dens0_bs * exp(-abs(precip_bs(j)) / pbst_bs - &
+                    abs(precip_rain(j)) / prt_bs) * exp(-max(tsurf(j) - RTT, 0.)))
+            rhos(j) = rhofresh_bs + (rhohard_bs - rhofresh_bs) * (1. - exp(-agesno(j) * 86400.0 / tau_dens))
+            ! blowing snow flux formula used in MAR
+            ustart(j) = ustart0(j) * exp(max(rhoice_bs / rhofresh_bs - rhoice_bs / rhos(j), 0.)) * exp(max(0., rhos(j) - rhohard_bs))
+            ! we have multiplied by exp to prevent erosion when rhos>rhohard_bs
+            ! computation of qbs at the top of the saltation layer
+            ! default formulation from MAR model (Amory et al. 2021, Gallee et al. 2001)
+            esalt = 1. / (c_esalt_bs * max(1.e-6, ustar(j)))
+            hsalt(j) = 0.08436 * (max(1.e-6, ustar(j))**1.27)
+            qsalt(j) = (max(ustar(j)**2 - ustart(j)**2, 0.)) / (RG * hsalt(j)) * esalt
+            ! calculation of erosion (flux positive towards the surface here)
+            ! consistent with implicit resolution of turbulent mixing equation
+            ! Nemoto and Nishimura 2004 show that steady-state saltation is achieved within a time tau_eqsalt_bs of about 10s
+            ! we thus prevent snowerosion (snow particle transfer from the saltation layer to the first model level)
+            ! integrated over tau_eqsalt_bs to exceed the total mass of snow particle in the saltation layer
+            ! (rho*qsalt*hsalt)
+            maxerosion = hsalt(j) * qsalt(j) * rhod(j) / tau_eqsalt_bs
+            fluxbs_2(j) = rhod(j) * ws1(j) * cdragh(j) * zeta_bs * (AcoefQBS(j) - qsalt(j)) &
+                    / (1. - rhod(j) * ws1(j) * cdragh(j) * zeta_bs * BcoefQBS(j) * dtime)
+            fluxbs_2(j) = max(-maxerosion, fluxbs_2(j))
+          endif
+        enddo
+
+
+
+
+        ! final flux and outputs
+        do j = 1, knon
+          ! total flux is the erosion of fresh snow +
+          ! a fraction of the underlying snow (if all the fresh snow has been eroded)
+          ! the calculation of the fraction is quite delicate since we do not know
+          ! how much time was needed to erode the fresh snow. We assume that this time
+          ! is dt*exp(-(abs(fluxbs1)-precipsnow)/precipsnow)=dt*bsweight_fresh
+
+          fluxbs(j) = fluxbs_1(j) + fluxbs_2(j) * (1. - bsweight_fresh(j))
+          i = knindex(j)
+          zxustartlic(i) = ustart(j)
+          zxrhoslic(i) = rhos(j)
+          zxqsaltlic(i) = qsalt(j)
+        enddo
+
+      else ! not ok_bs
+        ! those lines are useful to calculate the snow age
+        CALL albsno(klon, knon, dtime, agesno(:), alb_neig(:), precip_snow(:))
+
+      endif ! if ok_bs
+
+
+
+      !****************************************************************************************
+      ! Calculate snow amount
+
+      !****************************************************************************************
+      IF (ok_bs) THEN
+        precip_totsnow(:) = precip_snow(:) + precip_bs(:)
+        evap_totsnow(:) = evap(:) - fluxbs(:) ! flux bs is positive towards the surface (snow erosion)
+      ELSE
+        precip_totsnow(:) = precip_snow(:)
+        evap_totsnow(:) = evap(:)
+      ENDIF
+
+      CALL fonte_neige(knon, is_lic, knindex, dtime, &
+      tsurf, precip_rain, precip_totsnow, &
+      snow, qsol, tsurf_new, evap_totsnow &
 #ifdef ISO    
     ,fq_fonte_diag,fqfonte_diag,snow_evap_diag,fqcalving_diag     &
     ,max_eau_sol_diag,runoff_diag,run_off_lic_diag,coeff_rel_diag &
 #endif
-     )
+      )
 
 
@@ -641,75 +629,73 @@
 
 #endif
-   
-    WHERE (snow(1 : knon) < 0.0001) agesno(1 : knon) = 0.
-    zfra(1:knon) = MAX(0.0,MIN(1.0,snow(1:knon)/(snow(1:knon)+10.0)))  
-
+
+      WHERE (snow(1:knon) < 0.0001) agesno(1:knon) = 0.
+      zfra(1:knon) = MAX(0.0, MIN(1.0, snow(1:knon) / (snow(1:knon) + 10.0)))
 
     END IF ! landice_opt
 
 
-!****************************************************************************************
-! Send run-off on land-ice to coupler if coupled ocean.
-! run_off_lic has been calculated in fonte_neige or surf_inlandsis
-! If landice_opt>=2, corresponding call is done from surf_land_orchidee
-!****************************************************************************************
+    !****************************************************************************************
+    ! Send run-off on land-ice to coupler if coupled ocean.
+    ! run_off_lic has been calculated in fonte_neige or surf_inlandsis
+    ! If landice_opt>=2, corresponding call is done from surf_land_orchidee
+    !****************************************************************************************
     IF (type_ocean=='couple' .AND. landice_opt < 2) THEN
-       ! Compress fraction where run_off_lic is active (here all pctsrf(is_lic))
-       run_off_lic_frac(:)=0.0
-       DO j = 1, knon
-          i = knindex(j)
-          run_off_lic_frac(j) = pctsrf(i,is_lic)
-       ENDDO
-
-       CALL cpl_send_landice_fields(itime, knon, knindex, run_off_lic, run_off_lic_frac)
+      ! Compress fraction where run_off_lic is active (here all pctsrf(is_lic))
+      run_off_lic_frac(:) = 0.0
+      DO j = 1, knon
+        i = knindex(j)
+        run_off_lic_frac(j) = pctsrf(i, is_lic)
+      ENDDO
+
+      CALL cpl_send_landice_fields(itime, knon, knindex, run_off_lic, run_off_lic_frac)
     ENDIF
 
- ! transfer runoff rate [kg/m2/s](!) to physiq for output
-    runoff(1:knon)=run_off_lic(1:knon)/dtime
-
-       snow_o=0.
-       zfra_o = 0.
-       DO j = 1, knon
-           i = knindex(j)
-           snow_o(i) = snow(j)
-           zfra_o(i) = zfra(j)
-       ENDDO
-
-
-!albedo SB >>>
-     select case(NSW)
-     case(2)
-       alb_dir(1:knon,1)=alb1(1:knon)
-       alb_dir(1:knon,2)=alb2(1:knon)
-     case(4)
-       alb_dir(1:knon,1)=alb1(1:knon)
-       alb_dir(1:knon,2)=alb2(1:knon)
-       alb_dir(1:knon,3)=alb2(1:knon)
-       alb_dir(1:knon,4)=alb2(1:knon)
-     case(6)
-       alb_dir(1:knon,1)=alb1(1:knon)
-       alb_dir(1:knon,2)=alb1(1:knon)
-       alb_dir(1:knon,3)=alb1(1:knon)
-       alb_dir(1:knon,4)=alb2(1:knon)
-       alb_dir(1:knon,5)=alb2(1:knon)
-       alb_dir(1:knon,6)=alb2(1:knon)
-
-       IF ((landice_opt == 1) .AND. (iflag_albcalc == 2)) THEN
-       alb_dir(1:knon,1)=alb6(1:knon,1)
-       alb_dir(1:knon,2)=alb6(1:knon,2)
-       alb_dir(1:knon,3)=alb6(1:knon,3)
-       alb_dir(1:knon,4)=alb6(1:knon,4)
-       alb_dir(1:knon,5)=alb6(1:knon,5)
-       alb_dir(1:knon,6)=alb6(1:knon,6)
-       ENDIF
-
-     end select
-alb_dif=alb_dir
-!albedo SB <<<
-
+    ! transfer runoff rate [kg/m2/s](!) to physiq for output
+    runoff(1:knon) = run_off_lic(1:knon) / dtime
+
+    snow_o = 0.
+    zfra_o = 0.
+    DO j = 1, knon
+      i = knindex(j)
+      snow_o(i) = snow(j)
+      zfra_o(i) = zfra(j)
+    ENDDO
+
+
+    !albedo SB >>>
+    select case(NSW)
+    case(2)
+      alb_dir(1:knon, 1) = alb1(1:knon)
+      alb_dir(1:knon, 2) = alb2(1:knon)
+    case(4)
+      alb_dir(1:knon, 1) = alb1(1:knon)
+      alb_dir(1:knon, 2) = alb2(1:knon)
+      alb_dir(1:knon, 3) = alb2(1:knon)
+      alb_dir(1:knon, 4) = alb2(1:knon)
+    case(6)
+      alb_dir(1:knon, 1) = alb1(1:knon)
+      alb_dir(1:knon, 2) = alb1(1:knon)
+      alb_dir(1:knon, 3) = alb1(1:knon)
+      alb_dir(1:knon, 4) = alb2(1:knon)
+      alb_dir(1:knon, 5) = alb2(1:knon)
+      alb_dir(1:knon, 6) = alb2(1:knon)
+
+      IF ((landice_opt == 1) .AND. (iflag_albcalc == 2)) THEN
+        alb_dir(1:knon, 1) = alb6(1:knon, 1)
+        alb_dir(1:knon, 2) = alb6(1:knon, 2)
+        alb_dir(1:knon, 3) = alb6(1:knon, 3)
+        alb_dir(1:knon, 4) = alb6(1:knon, 4)
+        alb_dir(1:knon, 5) = alb6(1:knon, 5)
+        alb_dir(1:knon, 6) = alb6(1:knon, 6)
+      ENDIF
+
+    end select
+    alb_dif = alb_dir
+    !albedo SB <<<
 
   END SUBROUTINE surf_landice
 
-!****************************************************************************************
+  !****************************************************************************************
 
 END MODULE surf_landice_mod
